<?php
  /**
   * Title: processSingleSession.php
   * Description: This file contains the code used to process a single test session.
   * Copyright: Copyright (c) 2005
   * Company: University of Aveiro / Institute of Telecommunications - Aveiro pole 
   * @author Helder Veiga 
   * @version 2.1
	 * @Last updated: 9-12-2005
 	 *
 	 * Copyright (C) 2005  Helder Veiga 
 	 *
 	 * This program is free software; you can redistribute it and/or
 	 * modify it under the terms of the GNU General Public License
 	 * as published by the Free Software Foundation; either version 2
 	 * of the License, or (at your option) any later version.
 	 *
 	 * This program is distributed in the hope that it will be useful,
 	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 	 * GNU General Public License for more details.  A HTML version of 
 	 * the GNU General Public License can be seen at
 	 * http://www.gnu.org/licenses/gpl.html.
 	 *
	 */
	 
  // Report all errors except E_NOTICE, E_STRICT & E_WARNING. 
	// We should disable E_WARNING to use fsockopen to detect connectivity to OWAMP elements.
  error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_WARNING);

	// We must start the session to be able to use the variables $_SESSION to set the errors.
  session_start();
	
	$link = $_GET['link'];  // Is the link of the page to be presented, after the execution of this request session.
	                        // If this is an EMP web site the JOWAMP_About page should be presented, otherwise the JOWAMP page will be presented.
	if($link!="../jowamp.php")  // EMP web site
	  $_SESSION['EMP'] = 1;
	else // JOWAMP web site
	  $_SESSION['EMP'] = 0;
		
  // Include the function and constant definition file where all needed functions and constants are definied.
	include("./JOWAMP_AuxiliaryFunctions.php");
	include("./JOWAMP_Constants.php");
			 		
	/* Check if server, sender and Receiver exits. If not, this session will not be started.*/
	
	// Check if server exists
	if(!ConnectionSetup($_SERVER["HTTP_HOST"],$serverTCPport)){
	  $use = $_SERVER["HTTP_HOST"];
    $_SESSION['Error'] = ("Sorry, the machine with IP: <strong>$use</strong> doesn't have a Server (port $serverTCPport) installed or the connection to it is broken.");
		header("Location: JOWAMP_Error.php");
		die();
	}	
	
	// Check if sender exists
  $senderAddress = $_GET['senderAddress'];
	verifySenderAddress(&$senderAddress,&$senderTCPport,&$error);
	if(isset($error)){
	  $_SESSION['Error'] = $error;
		header("Location: JOWAMP_Error.php");
		die();	
	} 
					
	if(!ConnectionSetup($senderAddress,$senderTCPport)){
	  $use = $senderAddress;
    $_SESSION['Error'] = ("Sorry, the machine with IP: <strong>$use</strong> doesn't have a Session-Sender installed (port $senderTCPport) or the connection to it is broken. Please try <a href='JOWAMP_ShowPage.php?link=JOWAMP_SingleSession.php' title='again'>again</a>.");
		header("Location: JOWAMP_Error.php");
		die();
	}
	
	// Check if receiver exists
	verifyReceiverAddress($_GET['receiverAddress'],&$error);
	if(isset($error)){
	  $_SESSION['Error'] = $error;
		header("Location: JOWAMP_Error.php");
		die();	
	}
	
	if(!ConnectionSetup($_GET['receiverAddress'],$receiverTCPport)){
	  $use = $_GET['receiverAddress'];
    $_SESSION['Error'] = ("Sorry, the machine with IP: <strong>$use</strong> doesn't have a Session-Receiver installed (port $receiverTCPport) or the connection to it is broken. Please try <a href='JOWAMP_ShowPage.php?link=JOWAMP_SingleSession.php' title='again'>again</a>.");
		header("Location: JOWAMP_Error.php");
		die();
	}
 
  // When sender or receiver address is loopback address, both have to be loopback address.
	if(((($senderAddress == "127.0.0.1") || ($senderAddress == "localhost"))&&(($_GET['receiverAddress'] != "127.0.0.1") && ($_GET['receiverAddress'] != "localhost"))) ||
	  ((($_GET['receiverAddress'] == "127.0.0.1") || ($_GET['receiverAddress'] == "localhost"))&&(($senderAddress != "127.0.0.1") && ($senderAddress != "localhost")))){
		$_SESSION['Error'] = ("When sender or receiver address is loopback address, both have to be loopback address. Please try <a href='JOWAMP_ShowPage.php?link=JOWAMP_SingleSession.php' title='again'>again</a>.");
		header("Location: JOWAMP_Error.php");
		die(); 
	}
		 
  // Determine mbz_iPVN. Note: Both senderAddress and receiverAddress should be IPv6 or IPv4 addresses. If one of them 
	// is an IPv6 and the other is IPv4 the session should be rejected. As specified in the OWAMP specification, they should
	// have the same IP version. 
	if(substr_count($_GET['senderAddress'], "[")&&substr_count($_GET['receiverAddress'], "[")) // IPv6
	  $mbz_iPVN = 6;
	else  // Not IPv6
	  if(!substr_count($_GET['senderAddress'], "[")&&!substr_count($_GET['receiverAddress'], "[")) // IPv4
		  $mbz_iPVN = 4;
		else{
		  $_SESSION['Error'] = ("Sorry, IP addresses of sender and receiver should have the same version (IPv6 or IPv4). Please try <a href='JOWAMP_ShowPage.php?link=JOWAMP_SingleSession.php' title='again'>again</a>.");
		  header("Location: JOWAMP_Error.php");
		  die();
	  }
				
	$confSender = 0;
	$confReceiver = 1;
	$numberOfScheduleSlots = $_GET['numberOfScheduleSlots'];
	$numberOfPackets = $_GET['numberOfPackets'];
	$senderPort = 0;    // use a free port
	$receiverPort = 0;  // use a free port
	$senderAddress = $senderAddress.":$senderTCPport";
	$receiverAddress = $_GET['receiverAddress'];	
	$paddingLength = $_GET['paddingLength'];
	$year = $_GET['year'];
	$month = $_GET['month'];
	$date = $_GET['date'];
	$hour = $_GET['hour'];
	$minute = $_GET['minute'];
	$second = $_GET['second'];
	$timeOut = $_GET['timeout'];
	$typePDescriptor_Type = 0; 
	$typePDescriptor_Value = 0; 
	$slotType = $_GET['slotType'];
	$slotParameter = $_GET['slotParameter'];
	if($slotParameter==0)   // Can not be zero.
	  $slotParameter = 1;
	$link = $_GET['link'];  // Is the link of the page to be presented, after the execution of this request session.
	                        // If this is an EMP web site the JOWAMP_About page should be presented, otherwise the JOWAMP page will be presented.
  
	// Test if startTime is not in the past. If startTime in the past the session should not be 
	// processed.
                  
	$startTime = mktime ( $hour, $minute, $second, $month, $date, $year);
  
	if($startTime < getTime()){
	  $_SESSION['Error'] = "The Start time introduced is not valid (The Start time is in the past). Please try <a href='JOWAMP_ShowPage.php?link=JOWAMP_SingleSession.php' title='again'>again</a>.";
	  header("Location: JOWAMP_Error.php");
		die();
	}
 		
	if(strlen($NTPserverAddress) == 0)		           
  	$parameters = "$userID $serverAddress $confSender $confReceiver $numberOfScheduleSlots $numberOfPackets $senderPort $receiverPort $senderAddress $receiverAddress $paddingLength $year $month $date $hour $minute $second $timeOut $typePDescriptor_Type $typePDescriptor_Value $slotType $slotParameter $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $TableSS";
  else
  	$parameters = "$userID $serverAddress $confSender $confReceiver $numberOfScheduleSlots $numberOfPackets $senderPort $receiverPort $senderAddress $receiverAddress $paddingLength $year $month $date $hour $minute $second $timeOut $typePDescriptor_Type $typePDescriptor_Value $slotType $slotParameter $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $TableSS $NTPserverAddress $updateInterval";

 						
  execInBackground("java -classpath ./owamp_protocol OWAMP_ControlClient","$parameters");
		  
  ?>
  
<meta HTTP-EQUIV="REFRESH" content="0; url=<?php echo $link;?>">	

